## scipy 1.6.0

=== doc/Makefile ===
# Makefile for Sphinx documentation

# If `python3` doesn't point to the Python you want to use (with Sphinx installed),
# then you can use, e.g., `make html PYTHON=python3.7` to specify a Python executable
PYTHON = python3

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = LANG=C $(PYTHON) -msphinx
PAPER         =

FILES=

# Internal variables.
PAPEROPT_a4     = -D "latex_elements.papersize=a4paper"
PAPEROPT_letter = -D "latex_elements.papersize=letterpaper"
ALLSPHINXOPTS   = -d build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html web pickle htmlhelp latex changes linkcheck \
        dist dist-build version-check

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  html-scipyorg  to make standalone HTML files with scipy.org theming"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  clean     to clean all build files/directories"
	@echo "  dist      to make a distribution-ready tree (installing Scipy in venv)"
	@echo "  doc-dist  to make a distribution-ready tree (assuming Scipy is installed)"
	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"
	@echo "  show      to show the html-scipyorg output"

clean:
	-rm -rf build/* source/generated


#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current scipy version, and extract docs from it.
# We have to be careful of some issues:
#
# - Everything must be done using the same Python version
# - We must use eggs (otherwise they might override PYTHONPATH on import).
# - Different versions of easy_install install to different directories (!)
#

UPLOAD_DIR=/srv/docs_scipy_org/doc/scipy-$(RELEASE)

SCIPYVER:=$(shell $(PYTHON) -c "import scipy; print(scipy.version.git_revision[:10])" 2>/dev/null)
GITVER ?= $(shell cd ..; $(PYTHON) -c "from setup import git_version; \
				print(git_version()[:10])")

version-check:
ifeq "$(GITVER)" "Unknown"
	# @echo sdist build with unlabeled sources
else ifeq ("", "$(SCIPYVER)")
	@echo scipy not found, cannot build documentation without successful \"import scipy\"
	@exit 1
else ifneq ($(SCIPYVER),$(GITVER))
	@echo installed scipy $(SCIPYVER) != current repo git version \'$(GITVER)\'
	@echo use '"make dist"' or '"GITVER=$(SCIPYVER) make $(MAKECMDGOALS) ..."'
	@exit 1
else
	# for testing
	# @echo installed scipy $(SCIPYVER) matches git version $(GITVER); exit 1
endif

dist:
	install -d build
	rm -rf build/env
	$(PYTHON) -mvenv --system-site-packages build/env
	$(CURDIR)/build/env/bin/python -mpip install Sphinx
	$(CURDIR)/build/env/bin/python -mpip install ..
	make PYTHON="$(CURDIR)/build/env/bin/python" doc-dist

doc-dist: VERSIONWARNING=-t versionwarning

doc-dist: html-scipyorg html
	test -d build/latex || make latex
	make -C build/latex all-pdf LATEXOPTS="-halt-on-error"
	-test -d build/htmlhelp || make htmlhelp-build
	-rm -rf build/dist
	mkdir -p build/dist
	cp -r build/html-scipyorg build/dist/reference
	touch build/dist/index.html
	(cd build/html && zip -9qr ../dist/scipy-html.zip .)
	cp build/latex/scipy-ref.pdf build/dist
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s
	cd build/dist && tar czf ../dist.tar.gz *

upload:
	# SSH must be correctly configured for this to work.
	# Assumes that ``make dist`` was already run
	# Example usage: ``make upload USERNAME=rgommers RELEASE=0.17.0``
	ssh $(USERNAME)@new.scipy.org mkdir -p $(UPLOAD_DIR)
	scp build/dist.tar.gz $(USERNAME)@new.scipy.org:$(UPLOAD_DIR)
	ssh $(USERNAME)@new.scipy.org tar xvC $(UPLOAD_DIR) \
	    -zf $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org mv $(UPLOAD_DIR)/scipy-ref.pdf \
	    $(UPLOAD_DIR)/scipy-ref-$(RELEASE).pdf
	ssh $(USERNAME)@new.scipy.org mv $(UPLOAD_DIR)/scipy-html.zip \
	    $(UPLOAD_DIR)/scipy-html-$(RELEASE).zip
	ssh $(USERNAME)@new.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org ln -snf scipy-$(RELEASE) /srv/docs_scipy_org/doc/scipy

#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

html: version-check html-build
html-build:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) build/html $(FILES)
	@echo
	@echo "Build finished. The HTML pages are in build/html."

html-scipyorg:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -WT --keep-going -t scipyorg $(VERSIONWARNING) -b html $(ALLSPHINXOPTS) build/html-scipyorg $(FILES)
	@echo
	@echo "Build finished. The HTML pages are in build/html-scipyorg."

latex: version-check latex-build
latex-build:
	mkdir -p build/latex build/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex $(FILES)
	$(PYTHON) postprocess.py tex build/latex/*.tex
	@echo
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

coverage: build version-check
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: version-check
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: version-check
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

show:
	@python -c "import webbrowser; webbrowser.open_new_tab('file://$(PWD)/build/html-scipyorg/index.html')"

=== scipy/optimize/_highs/CMakeLists.txt ===
# The top-level CMake file is there to bring all modules into scope. That
# means, adding the subdirectories for all CMake projects in this tree, and
# finding external libraries and turning them into imported targets.

cmake_minimum_required(VERSION 3.15)

project(HIGHS VERSION 1.0 LANGUAGES CXX C)

# use C++11 standard
set(CMAKE_CXX_STANDARD 11)

### Require out-of-source builds
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
    message(FATAL_ERROR "You cannot build in a source directory (or any directory with a CMakeLists.txt file). 
    Please make a build subdirectory. Feel free to remove CMakeCache.txt and CMakeFiles.")
endif()

# Use OpenMP if version is high enough.
option(OPENMP "OpenMP" OFF)
find_package(OpenMP 3.0)
if(OpenMP_CXX_FOUND)
    message(STATUS "Linking with OpenMP... ")
    set(OPENMP ON)
endif()

# Fast build: No interfaces (apart from c); No ipx; New (short) ctest instances, 
# static library and exe without PIC. Used for gradually updating the CMake 
# targets build and install / export.

# Note: Not ON by default. Still need to fix the exe generation dir: rename from 
# app/ to bin/
option(FAST_BUILD "Fast build: only build static lib and exe and quick test." OFF)
if (NOT FAST_BUILD)

set(HIGHS_VERSION_PATCH 0)

set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE}")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE}")

find_package(PkgConfig)

include(CPack)
set(CPACK_RESOURCE_FILE_LICENSE "${HIGHS_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${HIGHS_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${HIGHS_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${HIGHS_VERSION_PATCH}")
set(CPACK_PACKAGE_VENDOR "University of Edinburgh")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${HIGHS_BINARY_DIR}/lib)

option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Export all symbols into the DLL" ON)

find_program(GIT git)
if((GIT) AND (EXISTS ${HIGHS_SOURCE_DIR}/.git))
    execute_process(
        COMMAND ${GIT} describe --always --dirty
        WORKING_DIRECTORY ${HIGHS_SOURCE_DIR}
        OUTPUT_VARIABLE GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
    string(REGEX REPLACE "^.*-g" "" GITHASH ${GITHASH})
else()
    set(GITHASH "n/a")
endif()
message(STATUS "Git hash: " ${GITHASH})

string(TIMESTAMP TODAY "%Y-%m-%d")
message(STATUS "Compilation date: " ${TODAY})

set(EXT_PRESOLVE_DIR "" CACHE STRING "Path to the external presolving library")
if(EXT_PRESOLVE_DIR)
    message(STATUS "External presolve: " ${EXT_PRESOLVE_DIR})
    include_directories(${EXT_PRESOLVE_DIR}/src)
    include_directories(${EXT_PRESOLVE_DIR}/external)
endif()



# For the moment keep above coverage part in case we are testing at CI.
option(CI "CI extended tests" ON)

# Coverage part
# 'make coverage' to start the coverage process
option(HIGHS_COVERAGE "Activate the code coverage compilation" OFF)
if (HIGHS_COVERAGE)
  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG}    -O0 --coverage")
    set(CMAKE_CXX_FLAGS_DEBUG  "${CMAKE_CXX_FLAGS_DEBUG}  -O0 --coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -O0 --coverage")
  endif ()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   -fprofile-arcs -ftest-coverage -Xclang -coverage-cfg-checksum -Xclang -coverage-no-function-names-in-data -Xclang -coverage-version='408*'")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage -Xclang -coverage-cfg-checksum -Xclang -coverage-no-function-names-in-data -Xclang -coverage-version='408*'")
  endif ()
endif ()

if (HIGHS_COVERAGE)
  if (NOT CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    message(FATAL_ERROR "Warning: to enable coverage, you must compile in DEBUG mode")
  endif ()
endif ()

if (HIGHS_COVERAGE)
  if (WIN32)
    message(FATAL_ERROR "Error: code coverage analysis is only available under Linux for now.")
  endif ()
  
  find_program(GCOV_PATH gcov)
  find_program(LCOV_PATH lcov)
  find_program(GENHTML_PATH genhtml)

  if (NOT GCOV_PATH)
    message(FATAL_ERROR "gcov not found! Please install lcov and gcov. Aborting...")
  endif ()
  
  if (NOT LCOV_PATH)
    message(FATAL_ERROR "lcov not found! Please install lcov and gcov. Aborting...")
  endif ()
  
  if (NOT GENHTML_PATH)
    message(FATAL_ERROR "genhtml not found! Please install lcov and gcov. Aborting...")
  endif ()
  
  # Capturing lcov counters and generating report
  if (NOT CI)
    add_custom_target(coverage
                    COMMAND ${LCOV_PATH} --directory ${CMAKE_BINARY_DIR} --zerocounters
                    COMMAND ${LCOV_PATH} --capture --initial --directory ${CMAKE_BINARY_DIR}/bin --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${CMAKE_CTEST_COMMAND} -LE "(LONG|FAIL)" || true
                    COMMAND ${LCOV_PATH} --capture --directory ${CMAKE_BINARY_DIR}/bin --directory ${CMAKE_BINARY_DIR}/src --directory ${CMAKE_BINARY_DIR}/app --directory ${CMAKE_BINARY_DIR}/check --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${LCOV_PATH} --remove "*/usr/include/*" --output-file ${CMAKE_BINARY_DIR}/coverage.info.cleaned
                    COMMAND ${GENHTML_PATH} -o ${CMAKE_BINARY_DIR}/coverage ${CMAKE_BINARY_DIR}/coverage.info.cleaned
                    COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_BINARY_DIR}/coverage.info.cleaned
            VERBATIM
                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                    COMMENT "Resetting code coverage counters to zero.
    Processing code coverage counters and generating report.
    You can zip the directory ${CMAKE_BINARY_DIR}/coverage and upload the content to a web server.")
  else()
    add_custom_target(ci_cov
                    COMMAND ${LCOV_PATH} --directory ${CMAKE_BINARY_DIR} --zerocounters
                    COMMAND ${LCOV_PATH} --capture --initial --directory ${CMAKE_BINARY_DIR}/bin --output-file ${CMAKE_BINARY_DIR}/coverage.info
                    COMMAND ${CMAKE_COMMAND} -E chdir ${CMAKE_BINARY_DIR} ${CMAKE_CTEST_COMMAND} -LE "(LONG|FAIL)" || true
                    COMMAND ${LCOV_PATH} --capture --directory ${CMAKE_BINARY_DIR}/bin --directory ${CMAKE_BINARY_DIR}/src --directory ${CMAKE_BINARY_DIR}/app --directory ${CMAKE_BINARY_DIR}/check --output-file ${CMAKE_BINARY_DIR}/coverage.info
		    VERBATIM
                    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                    COMMENT "Resetting code coverage counters to zero.")
  endif()
endif ()

option(SCIP_DEV "SCIP  development" OFF)
if (NOT (${SCIP_DEV} STREQUAL  "OFF"))
    message(STATUS "SCIP  development: " ${SCIP_DEV})
endif()

option(HiGHSDEV "HiGHS development" OFF)
if (NOT (${HiGHSDEV} STREQUAL  "OFF"))
    message(STATUS "HiGHS development: " ${HiGHSDEV})
endif()

set(OSI_ROOT "" CACHE PATH "Osi root folder.")
if (NOT "${OSI_ROOT}" STREQUAL "")
    # if OSI_ROOT is set, then overwrite PKG_CONFIG_PATH
    message(STATUS "OSI root folder set: " ${OSI_ROOT})
    set(ENV{PKG_CONFIG_PATH}  "${OSI_ROOT}/lib/pkgconfig")
endif ()
unset(OSI_ROOT CACHE)

pkg_check_modules(OSI osi)
if (OSI_FOUND)
    # need to come before adding any targets (add_executable, add_library)
    link_directories(${OSI_LIBRARY_DIRS})
    include_directories(${OSITEST_INCLUDE_DIRS})
endif (OSI_FOUND)

set(IPX_ON ON)
#option(IPX_ON OFF)
#if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux" AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5))
#    set(IPX_ON ON)
#endif()

include(CheckLanguage)
check_language("Fortran")
if(CMAKE_Fortran_COMPILER)
    enable_language(Fortran)
    set(FORTRAN_FOUND ON)
else()
    set(FORTRAN_FOUND OFF)
endif(CMAKE_Fortran_COMPILER)

check_language("CSharp")
if(CMAKE_CSharp_COMPILER)
    enable_language(CSharp)
    set(CSHARP_FOUND ON)
else()
    set(CSHARP_FOUND OFF)
endif(CMAKE_CSharp_COMPILER)

option(GAMS_ROOT "GAMS root folder." "OFF")
if (NOT (${GAMS_ROOT} STREQUAL "OFF"))
    message(STATUS "GAMS root folder set: " ${GAMS_ROOT})
    set(GAMS_FOUND ON)
else ()
    set(GAMS_FOUND OFF)
endif ()

# whether to use shared or static libraries
option(SHARED "Build shared libraries" ON)
set(BUILD_SHARED_LIBS ${SHARED})
message(STATUS "Build shared libraries: " ${SHARED})

# make 'Release' the default build type
if(CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE Release)
endif()
if(CMAKE_BUILD_TYPE STREQUAL Release)
    set(HiGHSRELEASE ON)
endif()
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

configure_file(${HIGHS_SOURCE_DIR}/src/HConfig.h.in ${HIGHS_BINARY_DIR}/HConfig.h)
include_directories(
    ${HIGHS_BINARY_DIR}
    ${HIGHS_SOURCE_DIR}/app
    ${HIGHS_SOURCE_DIR}/external
    ${HIGHS_SOURCE_DIR}/src
    ${HIGHS_SOURCE_DIR}/src/io
    ${HIGHS_SOURCE_DIR}/src/ipm/ipx
    ${HIGHS_SOURCE_DIR}/src/ipm/basiclu
    ${HIGHS_SOURCE_DIR}/src/lp_data
    ${HIGHS_SOURCE_DIR}/src/mip
    ${HIGHS_SOURCE_DIR}/src/presolve
    ${HIGHS_SOURCE_DIR}/src/simplex
    ${HIGHS_SOURCE_DIR}/src/test
    ${HIGHS_SOURCE_DIR}/src/util)

# set the correct rpath for OS X
set(CMAKE_MACOSX_RPATH ON)

# explicitly switch on colored output for ninja
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    if(CMAKE_GENERATOR STREQUAL "Ninja")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fdiagnostics-color=always")
    endif()
endif()

# If Visual Studio targets are being built.
if(MSVC)
    add_definitions(/W4)
    add_definitions(/wd4100)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

# Function to set compiler flags on and off easily.
include(CheckCXXCompilerFlag)
function(enable_cxx_compiler_flag_if_supported flag)
    string(FIND "${CMAKE_CXX_FLAGS}" "${flag}" flag_already_set)
    if(flag_already_set EQUAL -1)
        check_cxx_compiler_flag("${flag}" flag_supported)
        if(flag_supported)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}" PARENT_SCOPE)
        endif()
        unset(flag_supported CACHE)
    endif()
endfunction()

# usage: turn pedantic on for even more warnings.
enable_cxx_compiler_flag_if_supported("-Wall")
enable_cxx_compiler_flag_if_supported("-Wextra")
enable_cxx_compiler_flag_if_supported("-Wno-unused-parameter")
enable_cxx_compiler_flag_if_supported("-pedantic")

#if(CMAKE_BUILD_TYPE STREQUAL Debug OR CMAKE_BUILD_TYPE STREQUAL debug)
#    enable_cxx_compiler_flag_if_supported("-D_GLIBCXX_DEBUG")
#endif()

if (IPX_ON)
    # use, i.e. don't skip the full RPATH for the build tree
    set(CMAKE_SKIP_BUILD_RPATH FALSE)

    # when building, don't use the install RPATH already
    # (but later on when installing)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()

# Targets
enable_testing()
add_subdirectory(app)
add_subdirectory(check)
add_subdirectory(src)


else()
message(STATUS "FAST BUILD set to on.
 Note: The HiGHS team is preparing for our first official release. If you
       experience any issues please let us know via email or on GitHub.")

# todo: remove patch once release is official. 
# add here to avoid compile errors.
set(HIGHS_VERSION_PATCH 0)
configure_file(${HIGHS_SOURCE_DIR}/src/HConfig.h.in ${HIGHS_BINARY_DIR}/HConfig.h)

# condition added to src/CMakeLists.txt
add_subdirectory(src)

# No changes in app/ apart from a relative path
add_subdirectory(app)

# check/ not added here, instead define fewer tests: 
# build, 3 feas, 1 infeas, 1 unbounded. 1 parallel, 1 no presolve
enable_testing()

# Check whether targets build OK.
add_test(NAME highs-lib-build
         COMMAND ${CMAKE_COMMAND}
                 --build ${HIGHS_BINARY_DIR}
                 --target libhighs
         )

set_tests_properties(highs-lib-build
                     PROPERTIES
                     RESOURCE_LOCK libhighs)

=== scipy/optimize/_highs/src/CMakeLists.txt ===
# Define library.
# Outdated CMake approach: update in progress
if (NOT FAST_BUILD)
include_directories(ipm/ipx/src)
include_directories(ipm/ipx/include)
include_directories(ipm/basiclu/src)
include_directories(ipm/basiclu/include)

if (IPX_ON)
set(basiclu_sources
    ipm/basiclu/src/basiclu_factorize.c
    ipm/basiclu/src/basiclu_solve_dense.c
    ipm/basiclu/src/lu_build_factors.c
    ipm/basiclu/src/lu_factorize_bump.c
    ipm/basiclu/src/lu_initialize.c
    ipm/basiclu/src/lu_markowitz.c
    ipm/basiclu/src/lu_setup_bump.c
    ipm/basiclu/src/lu_solve_sparse.c
    ipm/basiclu/src/basiclu_get_factors.c
    ipm/basiclu/src/basiclu_solve_for_update.c
    ipm/basiclu/src/lu_condest.c
    ipm/basiclu/src/lu_file.c
    ipm/basiclu/src/lu_internal.c
    ipm/basiclu/src/lu_matrix_norm.c
    ipm/basiclu/src/lu_singletons.c
    ipm/basiclu/src/lu_solve_symbolic.c
    ipm/basiclu/src/lu_update.c
    ipm/basiclu/src/basiclu_initialize.c
    ipm/basiclu/src/basiclu_solve_sparse.c
    ipm/basiclu/src/lu_pivot.c
    ipm/basiclu/src/lu_solve_dense.c
    ipm/basiclu/src/lu_solve_triangular.c
    ipm/basiclu/src/basiclu_object.c
    ipm/basiclu/src/basiclu_update.c
    ipm/basiclu/src/lu_dfs.c
    ipm/basiclu/src/lu_garbage_perm.c
    ipm/basiclu/src/lu_residual_test.c
    ipm/basiclu/src/lu_solve_for_update.c)

set(ipx_sources
    ipm/ipx/src/basiclu_kernel.cc
    ipm/ipx/src/basiclu_wrapper.cc
    ipm/ipx/src/basis.cc
    ipm/ipx/src/conjugate_residuals.cc
    ipm/ipx/src/control.cc
    ipm/ipx/src/crossover.cc
    ipm/ipx/src/diagonal_precond.cc
    ipm/ipx/src/forrest_tomlin.cc
    ipm/ipx/src/guess_basis.cc
    ipm/ipx/src/indexed_vector.cc
    ipm/ipx/src/info.cc
    ipm/ipx/src/ipm.cc
    ipm/ipx/src/ipx_c.cc
    ipm/ipx/src/iterate.cc
    ipm/ipx/src/kkt_solver.cc
    ipm/ipx/src/kkt_solver_basis.cc
    ipm/ipx/src/kkt_solver_diag.cc
    ipm/ipx/src/linear_operator.cc
    ipm/ipx/src/lp_solver.cc
    ipm/ipx/src/lu_factorization.cc
    ipm/ipx/src/lu_update.cc
    ipm/ipx/src/maxvolume.cc
    ipm/ipx/src/model.cc
    ipm/ipx/src/normal_matrix.cc
    ipm/ipx/src/sparse_matrix.cc
    ipm/ipx/src/sparse_utils.cc
    ipm/ipx/src/splitted_normal_matrix.cc
    ipm/ipx/src/starting_basis.cc
    ipm/ipx/src/symbolic_invert.cc
    ipm/ipx/src/timer.cc
    ipm/ipx/src/utils.cc)
endif()

set(sources
    ../external/filereaderlp/reader.cpp
    io/Filereader.cpp
    io/FilereaderLp.cpp
    io/FilereaderEms.cpp
    io/FilereaderMps.cpp
    io/HighsIO.cpp
    io/HMPSIO.cpp
    io/HMpsFF.cpp
    io/LoadOptions.cpp
    lp_data/Highs.cpp
    lp_data/HighsDebug.cpp
    lp_data/HighsInfo.cpp
    lp_data/HighsLp.cpp
    lp_data/HighsLpUtils.cpp
    lp_data/HighsModelUtils.cpp
    lp_data/HighsSolution.cpp
    lp_data/HighsSolutionDebug.cpp
    lp_data/HighsSolve.cpp
    lp_data/HighsStatus.cpp
    lp_data/HighsOptions.cpp
    mip/HighsMipSolver.cpp
    mip/SolveMip.cpp
    presolve/Presolve.cpp
    presolve/PresolveComponent.cpp
    presolve/PresolveAnalysis.cpp
    presolve/PresolveUtils.cpp
    presolve/HPreData.cpp
    simplex/HCrash.cpp
    simplex/HDual.cpp
    simplex/HDualRHS.cpp
    simplex/HDualRow.cpp
    simplex/HDualMulti.cpp
    simplex/HFactor.cpp
    simplex/HFactorDebug.cpp
    simplex/HighsSimplexAnalysis.cpp
    simplex/HighsSimplexInterface.cpp
    simplex/HMatrix.cpp
    simplex/HPrimal.cpp
    simplex/HQPrimal.cpp
#    simplex/HRanging.cpp
    simplex/HSimplex.cpp
    simplex/HSimplexDebug.cpp
    simplex/HSimplexReport.cpp
    simplex/HVector.cpp
    test/DevKkt.cpp
    test/KktCh2.cpp
    util/HighsSort.cpp
    util/HighsUtils.cpp
    util/stringutil.cpp
    interfaces/highs_c_api.cpp)

set(headers
    ../external/filereaderlp/builder.hpp
    ../external/filereaderlp/model.hpp
    ../external/filereaderlp/reader.hpp
    ipm/IpxStatus.h
    io/Filereader.h
    io/FilereaderLp.h
    io/FilereaderEms.h
    io/FilereaderMps.h
    io/HMpsFF.h
    io/HMPSIO.h
    io/HighsIO.h
    io/LoadOptions.h
    lp_data/HConst.h
    lp_data/HighsAnalysis.h
    lp_data/HighsDebug.h
    lp_data/HighsInfo.h
    lp_data/HighsLp.h
    lp_data/HighsLpUtils.h
    lp_data/HighsModelUtils.h
    lp_data/HighsModelObject.h
    lp_data/HighsModelObjectUtils.h
    lp_data/HighsOptions.h
    lp_data/HighsSolution.h
    lp_data/HighsSolutionDebug.h
    lp_data/HighsSolve.h
    lp_data/HighsStatus.h
    mip/HighsMipSolver.h
    mip/SolveMip.h
    simplex/HApp.h
    simplex/FactorTimer.h
    simplex/HCrash.h
    simplex/HDual.h
    simplex/HDualRow.h
    simplex/HDualRHS.h
    simplex/HFactor.h
    simplex/HFactorDebug.h
    simplex/HighsSimplexAnalysis.h
    simplex/HighsSimplexInterface.h
    simplex/HMatrix.h
    simplex/HPrimal.h
    simplex/HQPrimal.h
#    simplex/HRanging.h
    simplex/HSimplex.h
    simplex/HSimplexReport.h
    simplex/SimplexConst.h
    presolve/Presolve.h
    presolve/PresolveComponent.h
    presolve/PresolveAnalysis.h
    presolve/PresolveUtils.h
    presolve/HPreData.h
    simplex/HVector.h
    test/DevKkt.h
    test/KktCh2.h
    util/stringutil.h
    util/HighsComponent.h
    util/HighsRandom.h
    util/HighsSort.h
    util/HighsTimer.h
    util/HighsUtils.h
    Highs.h
    interfaces/highs_c_api.h
)

if (GAMS_FOUND)
    set(sources ${sources} interfaces/GAMS.cpp)
    set(sources ${sources} "${GAMS_ROOT}/apifiles/C/api/gmomcc.c")
    set(sources ${sources} "${GAMS_ROOT}/apifiles/C/api/gevmcc.c")
    include_directories(${GAMS_ROOT}/apifiles/C/api)
endif()

if (IPX_ON)
    set(headers ${headers} ipm/IpxWrapper.h ${basiclu_headers}
        ${ipx_headers})
    add_library(libbasiclu ${basiclu_sources})
    add_library(libipx ${ipx_sources})
    target_link_libraries(libipx libbasiclu)
else ()
    set(headers ${headers} ipm/IpxWrapperEmpty.h)
endif()

add_library(libhighs ${sources})

if (IPX_ON)
    target_link_libraries(libhighs libipx)
endif()

if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(libhighs PROPERTIES
        VERSION 
        ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
        SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
else()
    # create static highs library with pic
    set_target_properties(libhighs PROPERTIES
        POSITION_INDEPENDENT_CODE on)
endif()

# on UNIX system the 'lib' prefix is automatically added
set_target_properties(libhighs PROPERTIES
    OUTPUT_NAME "highs"
    MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

if (IPX_ON)
    set_target_properties(libipx PROPERTIES
        OUTPUT_NAME "ipx"
        MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set_target_properties(libbasiclu PROPERTIES
        OUTPUT_NAME "basiclu"
        MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()

include(CheckLanguage)
check_language("Fortran")
if(FORTRAN_FOUND)
    set(fortransources interfaces/highs_lp_solver.f90)
    set(CMAKE_Fortran_MODULE_DIRECTORY ${HIGHS_BINARY_DIR}/modules)
    add_library(FortranHighs interfaces/highs_lp_solver.f90)
    target_link_libraries(FortranHighs PUBLIC libhighs)
    install(TARGETS FortranHighs
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        INCLUDES DESTINATION include
        MODULES DESTINATION modules)
    set_target_properties(FortranHighs PROPERTIES INSTALL_RPATH
        "${CMAKE_INSTALL_PREFIX}/lib")
endif(FORTRAN_FOUND)

check_language("CSharp")
if(CSHARP_FOUND)
    message(STATUS "CSharp supported")
    set(csharpsources
    interfaces/highs_csharp_api.cs)
    add_library(HighsCsharp interfaces/highs_csharp_api.cs)
    target_compile_options(HighsCsharp PUBLIC "/unsafe")
    add_executable(csharpexample ../examples/call_highs_from_csharp.cs)
    target_compile_options(csharpexample PUBLIC "/unsafe")
    target_link_libraries(csharpexample PUBLIC HighsCsharp)
else()
    message(STATUS "No CSharp support")
endif()

if (OSI_FOUND)
    add_library(OsiHighs interfaces/OsiHiGHSSolverInterface.cpp)
    set(headers ${headers} interfaces/OsiHiGHSSolverInterface.hpp)

    target_include_directories(OsiHighs PUBLIC ${OSI_INCLUDE_DIRS})
    target_link_libraries(OsiHighs PUBLIC libhighs ${OSI_LIBRARIES})
    target_compile_options(OsiHighs PUBLIC ${OSI_CFLAGS_OTHER})

    if(${BUILD_SHARED_LIBS})
        set_target_properties(OsiHighs PROPERTIES
           VERSION 
           ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
           SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
    else()
        set_target_properties(OsiHighs PROPERTIES POSITION_INDEPENDENT_CODE on)
    endif()

    install(TARGETS OsiHighs
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        INCLUDES DESTINATION include)

    set_target_properties(OsiHighs PROPERTIES INSTALL_RPATH
        "${CMAKE_INSTALL_PREFIX}/lib")

    #configure and install the pkg-config file
    configure_file(${HIGHS_SOURCE_DIR}/osi-highs.pc.in
        "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/osi-highs.pc" @ONLY)
    install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/osi-highs.pc"
        DESTINATION lib/pkg-config)
endif()


# set the install rpath to the installed destination
set_target_properties(highs PROPERTIES INSTALL_RPATH
    "${CMAKE_INSTALL_PREFIX}/lib")

# install the header files of highs
foreach ( file ${headers} )
    get_filename_component( dir ${file} DIRECTORY )
    install( FILES ${file} DESTINATION include/${dir} )
endforeach()
install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION include)

if (IPX_ON)
    install(TARGETS libhighs libipx libbasiclu EXPORT highs-targets
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib
            INCLUDES DESTINATION include)

    # Add library targets to the build-tree export set
    export(TARGETS libhighs libipx libbasiclu
    FILE "${HIGHS_BINARY_DIR}/highs-targets.cmake")
else()
    install(TARGETS libhighs EXPORT highs-targets
            LIBRARY DESTINATION lib
            ARCHIVE DESTINATION lib
            INCLUDES DESTINATION include)

    # Add library targets to the build-tree export set
    export(TARGETS libhighs 
    FILE "${HIGHS_BINARY_DIR}/highs-targets.cmake")
endif()


# Configure the config file for the build tree:
# Either list all the src/* directories here, or put explicit paths in all the
# include statements.
# M reckons that the latter is more transparent, and I'm inclined to agree.
set(CONF_INCLUDE_DIRS "${HIGHS_SOURCE_DIR}/src" "${HIGHS_BINARY_DIR}")
configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}/highs-config.cmake" @ONLY)

# Configure the config file for the install
set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../include")
configure_file(${HIGHS_SOURCE_DIR}/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" @ONLY)

# Configure the pkg-config file for the install
configure_file(${HIGHS_SOURCE_DIR}/highs.pc.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" @ONLY)

# Install the targets of the highs export group, the config file so that other
# cmake-projects can link easily against highs, and the pkg-config flie so that
# other projects can easily build against highs
install(EXPORT highs-targets FILE highs-targets.cmake DESTINATION 
    lib/cmake/highs)
install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" 
    DESTINATION lib/cmake/highs)
install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" 
    DESTINATION lib/pkg-config)

else() 

# FAST_BUILD is set to on.
# At the moment used only for gradually updating the CMake targets build and install / export.
# Define library in modern CMake using target_*()
# No interfaces (apart from c); No ipx; New (short) ctest instances.
add_library(libhighs)
target_sources(libhighs PRIVATE 
    ../external/filereaderlp/reader.cpp
    io/Filereader.cpp
    io/FilereaderLp.cpp
    io/FilereaderEms.cpp
    io/FilereaderMps.cpp
    io/HighsIO.cpp
    io/HMPSIO.cpp
    io/HMpsFF.cpp
    io/LoadOptions.cpp
    lp_data/Highs.cpp

=== debian/changelog ===
scipy (1.6.0-2) unstable; urgency=medium

  * Team upload.
  * upload new upstream version to unstable

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Jan 2021 23:26:56 +1100

scipy (1.6.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 4.5.1
  * drop debian/python3-scipy.docs: Thanks.txt no longer shipped.
  * update debian/copyright for new features
    - benchmarks/benchmarks/go_benchmark_functions/*.py
      Copyright: 2013 Andrea Gavana <andrea.gavana@gmail.com>
      License: expat
    - scipy/fft/_pocketfft/pocketfft.cxx
      Copyright: 2010-2019 Max-Planck-Society, Martin Reinecke
      2019 Peter Bell. License: BSD-3-clause
    - scipy/fft/_pocketfft/pocketfft_hdronly.h
      Copyright: 2010-2019 Max-Planck-Society, Martin Reinecke
      2019 Peter Bell, 2003,2007-2014 Matteo Frigo,
      Massachusetts Institute of Technology. License: BSD-3-clause
    - scipy/optimize/_highs/*
      Copyright: 2020 ERGO-Code
      License: Expat
    - scipy/sparse/csgraph/_matching.pyx
      Copyright: 1987, A. Volgenant/Amsterdam School of Economics,
      University of Amsterdam. License: BSD-3-clause
    - scipy/_lib/uarray/*
      Copyright: 2018, Quansight-Labs
      License: BSD-3-clause

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Jan 2021 19:57:43 +1100

=== debian/control ===
Source: scipy
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Ondrej Certik <ondrej@certik.cz>,
           David Cournapeau <cournape@gmail.com>,
           Varun Hiremath <varun@debian.org>
Build-Depends: cython3 (>= 0.29.18),
               debhelper-compat (= 13),
               dh-python,
               gfortran,
               libblas-dev,
               liblapack-dev,
               liblbfgsb-dev,
               libsuitesparse-dev (>= 3.1.0-3),
               python3-all-dbg,
               python3-all-dev,
               python3-decorator,
               python3-numpy (>= 1:1.14.5),
               python3-numpy-dbg,
               python3-pybind11 (>= 2.4.3),
               python3-pytest,
               python3-setuptools
Build-Depends-Indep: dvipng,
                     python3-doc,
                     python3-docutils,
                     python3-matplotlib,
                     python3-numpydoc,
                     python3-sphinx (>= 2~),
                     rdfind,
                     symlinks,
                     texlive-latex-base,
                     texlive-latex-extra
Standards-Version: 4.5.1
Homepage: http://www.scipy.org/
Vcs-Git: https://salsa.debian.org/python-team/packages/scipy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/scipy

Package: python3-scipy
Architecture: any
Depends: python3-decorator,
         python3-numpy (>= 1:1.7.2),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: g++ | c++-compiler, python3-pil
Suggests: python-scipy-doc
Description: scientific tools for Python 3
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.

Package: python3-scipy-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: python3-dbg,
         python3-numpy-dbg (>= 1:1.7.2),
         python3-scipy (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: scientific tools for Python 3 - debugging symbols
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package provides debugging symbols for python3-scipy.

Package: python-scipy-doc
Depends: fonts-open-sans,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Section: doc
Architecture: all
Multi-Arch: foreign
Description: scientific library for Python - documentation
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package contains documentation for the SciPy library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/architecture.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)

PY3VERS:= $(shell py3versions -v -r debian/control)
PY3_DEFAULT:= $(shell py3versions -d)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	rm -rf build
	-rm -rf doc/source/fontList.cache
	-rm -rf doc/build
	-rm -rf debian/extra_bin
	find . -name "*.pyc" -exec rm {} \;
	dh_clean

override_dh_auto_configure:
	rm -f cythonize.dat
	touch scipy/linalg/_generate_pyx.py scipy/special/_generate_pyx.py
	python3 tools/cythonize.py

build-python%:
	pybuild -p$* --configure --configure-args "config_fc --noarch build"
	CFLAGS="-g -ggdb" \
          pybuild -p$* -ipython$*-dbg --configure --configure-args "config_fc --noarch build"

override_dh_auto_build-arch: $(PY3VERS:%=build-python%)

override_dh_auto_build-indep: build-$(PY3_DEFAULT)
	# generate documentation (see comment below) needs compiled scipy
	(export MPLCONFIGDIR=. ; \
	PYLIBPATH=`pybuild --print build_dir | grep $(PY3_DEFAULT) | awk '{print $$3}'`; \
	echo "building docs using PYLIBPATH=$$PYLIBPATH"; \
	PYTHONPATH=$$PYLIBPATH make -C doc html PYTHONPATH=$$PYLIBPATH PYVER=3)

override_dh_auto_test:
	echo "Build-time tests will be run after the installation dir is installed"

override_dh_auto_install:
	dh_auto_install -a -- --install-args "--root $(BASE)/tmp --force --no-compile --install-layout=deb";

override_dh_install-arch:
	dh_install
	find debian/python3-scipy -type f -name '*.cpython-3?d*.so' -delete
	find debian/python3-scipy-dbg ! -type d ! -name '*.cpython-3?d*.so' -delete
	find debian/python3-scipy-dbg -depth -empty -exec rmdir {} \;
	rm -fr $(BASE)/python-scipy*/usr/lib/python*/*-packages/scipy/weave/examples/

	# drop all the installed setup.py files
	find $(BASE)/ -name setup.py -delete
	find $(BASE)/ -name generate_ufuncs.py -delete

	set -e && for py in $(PY3VERS); do \
	  ln -sf /usr/lib/python3/dist-packages/decorator.py $(BASE)/python3-scipy/usr/lib/python$$py/dist-packages/scipy/_lib/decorator.py; \
	done

	# not ported to py3 in 0.10.1
	rm -rf $(BASE)/python3-scipy/usr/lib/python3/dist-packages/scipy/weave

	dh_numpy3
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p $(TMPDIR)
	-set -e && for pyvers in $(PY3VERS); do \
	  AUTOPKGTEST_TMP=$(TMPDIR) \
	  PYTHONPATH=$(BASE)/python3-scipy/usr/lib/python$$pyvers/dist-packages/ \
	  PYS=python$$pyvers TESTMODE=fast $(BASE)/tests/python3; \
	done
endif

override_dh_fixperms-arch:
	dh_fixperms
	set -e; for i in `find debian -mindepth 2 -type f ! -perm 755`; do \
		if head -1 $$i | grep -q '^#!' ; then                      \
	    		chmod +x $$i;                                      \
		fi ;                                                       \
	done
	chmod a-x debian/python3-scipy/usr/lib/python3/dist-packages/scipy/optimize/_shgo_lib/sobol_vec.gz
	sed -i '1s|.|#!/usr/bin/python3\n&|' $(BASE)/python3-scipy/usr/lib/python3/dist-packages/scipy/cluster/tests/test_vq.py
	sed -i '1s|.|#!/usr/bin/python3\n&|' $(BASE)/python3-scipy/usr/lib/python3/dist-packages/scipy/stats/tests/test_stats.py
	#replace all the usr/bin/env python
	find $(BASE)/python3-scipy/usr/lib/python3/ -name "*.py" -type f | xargs sed -i -e "1s#usr/bin/env\s\+python\s*\$$#usr/bin/env python3#"

override_dh_strip:
	dh_strip -ppython3-scipy --dbg-package=python3-scipy-dbg

override_dh_installdocs-indep:
	dh_installdocs -i

	rm -rf debian/python-scipy-doc/usr/share/doc/python-scipy-doc/html/_static/jquery.js
	dh_link -ppython-scipy-doc /usr/share/javascript/jquery/jquery.js /usr/share/doc/python-scipy-doc/html/_static/jquery.js

	rm -rf debian/python-scipy-doc/usr/share/doc/python-scipy-doc/html/_static/underscore.js
	dh_link -ppython-scipy-doc /usr/share/javascript/underscore/underscore.js /usr/share/doc/python-scipy-doc/html/_static/underscore.js

	dh_sphinxdoc -i -XMathJax.js
	find debian/python-scipy-doc/ -name scipy-mathjax | xargs rm -rf
	rdfind -outputname /dev/null -makesymlinks true -removeidentinode false debian/python-scipy-doc
	symlinks -r -s -c debian/python-scipy-doc

=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-scipy, python3-pytest, python3-all, python3-all-dev, python3-pil

# short test on all python versions including debug
Tests: python3-smoke
Depends: python3-scipy, python3-scipy-dbg, python3-pytest, python3-all, python3-all-dbg

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: openblas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libopenblas0

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: atlas
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libatlas3-base

#needs root for update-alternatives, build-essential for libc6-dev (ctype libm.so)
Tests: blis
Restrictions: needs-root
Depends: build-essential, python3-scipy, python3-pytest, python3, libblis3
